//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C1786D801AD.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C1786D801AD.cm

//## begin module%3C1786D801AD.cp preserve=no
//## end module%3C1786D801AD.cp

//## Module: Cstat%3C1786D801AD; Package body
//## Subsystem: XSFit::StatMethod::Cstat%3C178673021B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/StatMethod/Cstat/Cstat.cxx

//## begin module%3C1786D801AD.additionalIncludes preserve=no
//## end module%3C1786D801AD.additionalIncludes

//## begin module%3C1786D801AD.includes preserve=yes
//## end module%3C1786D801AD.includes

// Cstat
#include <XSFit/StatMethod/Cstat/Cstat.h>
//## begin module%3C1786D801AD.declarations preserve=no
//## end module%3C1786D801AD.declarations

//## begin module%3C1786D801AD.additionalDeclarations preserve=yes
#include <XSFit/Fit/Fit.h>
#include <XSModel/Model/Model.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSModel/GlobalContainer/ModelContainer.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/Data/BackCorr/Background.h>
#include <XSUtil/Error/Error.h>
#include <XSstreams.h>
#include <XSContainer.h>
#include <set>
#include <typeinfo>
using namespace XSContainer;
//## end module%3C1786D801AD.additionalDeclarations


// Class Cstat 

//## begin Cstat::FLOOR%421F46A103A4.attr preserve=no  private: static const Real {U} 1.0e-5
const Real Cstat::s_FLOOR = 1.0e-5;
//## end Cstat::FLOOR%421F46A103A4.attr

Cstat::Cstat()
  //## begin Cstat::Cstat%3B7BFB790023_const.hasinit preserve=yes
  : StatMethod("cstat"),
    m_firstDerivCoefficient(),
    m_secondDerivCoefficient(),
    m_fullName("C-Statistic"),
    m_scriptName("C-Statistic")
  //## end Cstat::Cstat%3B7BFB790023_const.hasinit
  //## begin Cstat::Cstat%3B7BFB790023_const.initialization preserve=yes
  //## end Cstat::Cstat%3B7BFB790023_const.initialization
{
  //## begin Cstat::Cstat%3B7BFB790023_const.body preserve=yes
  isDerivAnalytic(true);
  //## end Cstat::Cstat%3B7BFB790023_const.body
}

Cstat::Cstat(const Cstat &right)
  //## begin Cstat::Cstat%3B7BFB790023_copy.hasinit preserve=yes
  : StatMethod(right),
    m_firstDerivCoefficient(right.m_firstDerivCoefficient),
    m_secondDerivCoefficient(right.m_secondDerivCoefficient),
    m_fullName(right.m_fullName),
    m_scriptName(right.m_scriptName)
  //## end Cstat::Cstat%3B7BFB790023_copy.hasinit
  //## begin Cstat::Cstat%3B7BFB790023_copy.initialization preserve=yes
  //## end Cstat::Cstat%3B7BFB790023_copy.initialization
{
  //## begin Cstat::Cstat%3B7BFB790023_copy.body preserve=yes
   if (!checkForPoisson())
      tcout << "Warning: Cstat statistic is only valid for Poisson data." << std::endl;
  //## end Cstat::Cstat%3B7BFB790023_copy.body
}



//## Other Operations (implementation)
void Cstat::doPerform (Fit* fit)
{
  //## begin Cstat::doPerform%3B7BFF2B029B.body preserve=yes
    doReset(fit);

    Real cstat(0.);
    
    // for each model,
    ArrayContainer tmpQ(protoWorkspace());
    ModelMapConstIter ml (models->modelSet().begin());
    ModelMapConstIter mlEnd (models->modelSet().end());
    while (ml != mlEnd)
    {
        // add up the folded models for each spectrum [ >= indicates multiple sources]
        Model* m (ml->second);
        if (!m->isActive()) 
        {
           ++ml;
           continue;
        }
        ArrayContainer::const_iterator s = m->foldedModel().begin();
        ArrayContainer::const_iterator sEnd = m->foldedModel().end();
        while (s != sEnd)
        {
                size_t spectrumIndex (s->first);
                SpectralData* spectrum = m->spectrum(spectrumIndex);          
                const std::valarray<size_t>& IN = spectrum->indirectNotice();
                RealArray mod (s->second[IN]);
                if (tmpQ[spectrumIndex].size() == 0) tmpQ[spectrumIndex].resize(IN.size(),0.);
                tmpQ[spectrumIndex] += mod;
                ++s;
        }
        ++ml;
    }
    

    std::map<size_t,SpectralData*>::const_iterator   sp (fit->spectraToFit().begin());
    std::map<size_t,SpectralData*>::const_iterator   spEnd (fit->spectraToFit().end());
 
    // for each spectrum sum contributions.
    while(sp != spEnd) 
    {
	size_t spectrumIndex = sp->first;
	const SpectralData* spectrum = sp->second;
        const std::valarray<size_t>& IN = spectrum->indirectNotice();
        const size_t N (IN.size());
        
        RealArray ts (spectrum->exposureTime()*spectrum->areaScale()[IN]);
	RealArray S (ts * spectrum->spectrum()[IN]);
	const RealArray& model = tmpQ[spectrumIndex];
        const Background* background (spectrum->background());        

        if (spectrum->correction() && spectrum->correctionScale() != 0.0)
        {
           tcout << "Cstat: Correction data being ignored for spectrum "
             << spectrum->spectrumNumber() << std::endl;
        }

        if (!background)
        {
                for ( size_t i = 0; i < N; ++i)
                {
		   Real si = S[i];
		   Real tsi = ts[i];
		   Real yi = std::max(model[i], s_FLOOR/tsi);
		   cstat += tsi*yi;
                   if ( si > 0 ) cstat += si*(std::log(si)-std::log(tsi*yi)-1);
                }
        }
        else
        {
	   // case of a background spectrum in use
           Real bTime (background->data()->exposureTime());
           RealArray tb (background->data()->areaScale()[IN]);
           tb *= background->data()->backgroundScale()[IN];
           tb /= spectrum->backgroundScale()[IN];
           tb *= bTime;
           RealArray B (tb * background->spectrum()[IN]);
        
           // for notation, see the corresponding appendix in the XSPEC12 manual.
           for ( size_t i = 0; i < N; ++i)
           {
	      Real si = S[i];
	      Real bi = B[i];
	      Real tsi = ts[i];
	      Real tbi = tb[i];
              Real ti = ts[i] + tb[i];
	      Real yi = model[i];
              Real fi (0);

	      if ( fabs(si) <= SMALL )
	      {
		 cstat += tsi*yi - bi*std::log(tbi/ti);
	      }
	      else
	      {
		 if ( fabs(bi) <= SMALL )
		 {
		    if ( yi <= si/ti )
		    {
		       cstat += -tbi*yi - si*std::log(tsi/ti);
		    }
		    else
		    {
		       cstat += tsi*yi + si*(std::log(si)-std::log(tsi*yi)-1);
		    }
		 }
		 else
		 {
		    // now the main case where both data and background !=0
                    // Solve quadratic equation for fi, using Numerical Recipes technique
                    // to avoid round-off error that can easily cause problems here
                    // when b^2 >> ac.
                    Real a = ti;
                    Real b = ti*yi - si - bi;
                    Real c = -bi*yi;
                    Real sign = (b >= .0) ? 1.0 : -1.0;
                    Real q = -.5*(b + sign*sqrt(b*b - 4.0*a*c));
                    fi = q/a;
                    if (fi < .0) fi = c/q;

		    // note that at this point fi must be > 0 so the log 
		    // functions below will be valid.

                    cstat += tsi*yi + ti*fi - si*std::log(tsi*yi+tsi*fi)
		      - bi*std::log(tbi*fi) - si*(1-std::log(si)) 
		      - bi*(1-std::log(bi));

		 }

              }
           }  // end bin loop
	} // end if background
        
	++sp;

    } // end spectra loop

    Real bayesianPrior = bayes().lPrior(fit);           
    statistic(2.0*cstat - 2.0*bayesianPrior);

  //## end Cstat::doPerform%3B7BFF2B029B.body
}

void Cstat::doInitialize (Fit* fit)
{
  //## begin Cstat::doInitialize%3C5AAD52009F.body preserve=yes
        
  StatMethod::doInitialize(fit);
  
  // allocate for derivative coefficient arrays.
  std::map<size_t,SpectralData*>::const_iterator i = fit->spectraToFit().begin();
  std::map<size_t,SpectralData*>::const_iterator iEnd = fit->spectraToFit().end();
  while (i != iEnd)
  {
        size_t N = i->second->indirectNotice().size();
        m_firstDerivCoefficient[i->first].resize(N,0.);
        m_secondDerivCoefficient[i->first].resize(N,0.);
        ++i;
  }
  //## end Cstat::doInitialize%3C5AAD52009F.body
}

void Cstat::doDeallocate ()
{
  //## begin Cstat::doDeallocate%3C5AAD800286.body preserve=yes
    StatMethod::doDeallocate();

    m_firstDerivCoefficient.clear();
    m_secondDerivCoefficient.clear();
  //## end Cstat::doDeallocate%3C5AAD800286.body
}

void Cstat::doReset (Fit* fit)
{
  //## begin Cstat::doReset%3C6BE5D5005E.body preserve=yes

    std::set<string>::iterator ss (fit->activeModels().begin());
    std::set<string>::iterator ssEnd (fit->activeModels().end());
    while ( ss != ssEnd)
    {
          models->calculate(*ss);
          models->fold(*ss);
	  ++ss;
    }   

    // for each model,
    ArrayContainer tmpQ(protoWorkspace()); 
    ModelMapConstIter ml (models->modelSet().begin());      
    ModelMapConstIter mlEnd (models->modelSet().end());      
    while (ml != mlEnd)
    {
        // add up the folded models for each spectrum [ >= indicates multiple sources]
        Model* m (ml->second);
        if (!m->isActive()) 
        {
           ++ml;
           continue;
        }
        ArrayContainer::const_iterator s    = m->foldedModel().begin();
        ArrayContainer::const_iterator sEnd = m->foldedModel().end();
        while (s != sEnd)
        {
                size_t spectrumIndex (s->first);
                SpectralData* spectrum = m->spectrum(spectrumIndex);
                const std::valarray<size_t>& IN = spectrum->indirectNotice();
                RealArray mod (s->second[IN]);
                tmpQ[spectrumIndex] += mod;
                ++s;
        }
        ++ml;
    }    
    
    std::map<size_t,SpectralData*>::const_iterator sp    = fit->spectraToFit().begin();
    std::map<size_t,SpectralData*>::const_iterator spEnd = fit->spectraToFit().end();
    
    while(sp != spEnd) 
    {
        size_t spectrumIndex = sp->first;
        const SpectralData* spectrum  = sp->second;        
        const std::valarray<size_t>& IN  = spectrum->indirectNotice();
        const size_t N (IN.size());

        RealArray ts (spectrum->exposureTime()*spectrum->areaScale()[IN]);
        RealArray S (ts * spectrum->spectrum()[IN]);
        RealArray& diff1 = m_firstDerivCoefficient[spectrumIndex];
        RealArray& diff2 = m_secondDerivCoefficient[spectrumIndex];
        RealArray& model = tmpQ[spectrumIndex];
        const Background* background (spectrum->background());
        if (!background)
        {
           for ( size_t i = 0; i < N; ++i)
           {
 	      Real si = S[i];
	      Real tsi = ts[i];
              Real yi = std::max(model[i], s_FLOOR/tsi);
              diff1[i] = (si/yi) - tsi;
              diff2[i] = si/(yi*yi);
           }
        }
        else
        {
           // Variable definitions follow Appendix B of manual.
           Real bTime (background->data()->exposureTime());
           RealArray tb (background->data()->areaScale()[IN]);
           tb *= background->data()->backgroundScale()[IN];
           tb /= spectrum->backgroundScale()[IN];
           tb *= bTime;
           RealArray B (tb * background->spectrum()[IN]);

           for (size_t i=0; i<N; ++i)
           {
              Real si = S[i];
              Real bi = B[i];
	      Real tsi = ts[i];
	      Real tbi = tb[i];
	      Real ti = ts[i] + tb[i];
              Real yi = std::max(model[i], s_FLOOR/tsi);
	      if (fabs(si) <= SMALL)
	      {
		 // Special case if the data = 0 - note that in this case the 
		 // derivatives are independent of the background values
		 diff1[i] = -tsi;
		 diff2[i] = 0.;
	      }
              else
              {
                 if (fabs(bi) <= SMALL)
                 {
                    // If background bin is 0 but data is non-zero
		    if (yi <= si/ti )
		    {
		       diff1[i] = tbi;
		       diff2[i] = 0.;
		    }
		    else
		    {
 		       diff1[i] = (si/yi) - tsi;
		       diff2[i] = si/(yi*yi);
                    }
		 }
		 else
		 {
                    // Solve quadratic equation for fi, using Numerical Recipes technique
                    // to avoid round-off error that can easily cause problems here
                    // when b^2 >> ac.
                    Real a = ti;
		    Real b = ti*yi - si - bi;
		    Real c = -bi*yi;
		    Real sign = (b >= .0) ? 1.0 : -1.0;
                    Real q = -.5*(b + sign*sqrt(b*b - 4.0*a*c));
                    Real fi = q/a;
		    Real gi = 0.;
		    Real hi = 0.;
		    Real di = sqrt(b*b - 4.0*a*c);
                    if (fi < .0)
                    {
		       fi = c/q;
                       gi = (ti*yi - si + bi - di)/(2.0*di);
                       hi = 2.0*ti*si*bi/(di*di*di);
                    }
                    else
                    {
                       gi = (-ti*yi + si - bi - di)/(2.0*di);
                       hi = -2.0*ti*si*bi/(di*di*di);
                    }
                    diff1[i] = si*(1+gi)/(yi+fi) + bi*gi/fi - ts[i] -gi*ti;
                    diff2[i] = si*hi/(yi+fi) + si*(1+gi)*(1+gi)/((yi+fi)*(yi+fi)) 
                                 + bi*hi/fi + bi*gi*gi/(fi*fi) - ti*hi;
                 }
	      }
           
	   }
        }
	++sp;
    }
  //## end Cstat::doReset%3C6BE5D5005E.body
}

Cstat* Cstat::clone () const
{
  //## begin Cstat::clone%3C84ECD60316.body preserve=yes
  return new Cstat(*this);
  //## end Cstat::clone%3C84ECD60316.body
}

void Cstat::doReport (Fit* fit) const
{
  //## begin Cstat::doReport%3C90CF2702F9.body preserve=yes
  int degrees (0);
  size_t bins(0);
  degreesOfFreedom(fit,degrees,bins);
  using namespace std;
  ios_base::fmtflags saveFmt(tcout.flags());
  streamsize savePrec(tcout.precision());
  Real truncatedStat = setOutputFormat(fit);
  tcout << "\n C-statistic = " << setw(14) << truncatedStat << " using " 
                  << bins << " PHA bins and " << degrees 
                  << " degrees of freedom." << endl;
  if (!checkForPoisson())
      tcout << "\nWarning: Cstat statistic is only valid for Poisson data.\n" << std::endl;
  tcout.precision(savePrec);
  tcout.flags(saveFmt);
  //## end Cstat::doReport%3C90CF2702F9.body
}

Real Cstat::plotChi (Real obs, Real mod, Real error, Real areaTime, const Real& NODATA) const
{
  //## begin Cstat::plotChi%3DD26FB6010A.body preserve=yes
  Real point (0);
  // Presumeably areaTime is not .0 or it wouldn't have made it here.
  if ( obs > 0 )
  {
       obs *= areaTime;
       mod *= areaTime;
       if (mod > 0)
       {
          Real sign = (obs >= mod) ? 1.0 : -1.0;
          point = 2.0*sign*(mod - obs*(1 - (log(obs) - log(mod))));
       }
       else
          point = NODATA;
  }
  else
  {
        point = 2*mod*areaTime;       
  }      
  return point;                    
  //## end Cstat::plotChi%3DD26FB6010A.body
}

ArrayContainer Cstat::getDifferences (const Fit* fit) const
{
  //## begin Cstat::getDifferences%3FAFC0080256.body preserve=yes
  using namespace XSContainer;
  ArrayContainer result;
  
  SpectralDataMapConstIt  sm (fit->spectraToFit().begin());  
  SpectralDataMapConstIt  smEnd (fit->spectraToFit().end());  
  
  while (sm != smEnd)
  {
        size_t index = sm->first;
        const SpectralData* spectrum = sm->second;
        const std::valarray<size_t>& IN = spectrum->indirectNotice();
        result[index].resize(IN.size());
        result[index] = spectrum->spectrum()[IN];
        if (spectrum->background())
        {
                result[index] -= spectrum->background()->spectrum()[IN];
                if (spectrum->correction() && spectrum->correctionScale() != 0) 
                {
                        result[index] -=  spectrum->correctionScale()
                                *spectrum->correction()->spectrum()[IN];         
                }     
        }
        ++sm;  
  }
  
  
  ModelMapConstIter ml (models->modelSet().begin());      
  ModelMapConstIter  mlEnd (models->modelSet().end()); 
  while ( ml != mlEnd )
  {
        // D - F for each model. In the case where there are multiple
        // sources difference will be iteratively defined.
        Model* m (ml->second);
        if (m->isActive())
        {
                m->difference(result);                  
        }
        ++ml;
  }    
  return result;
  //## end Cstat::getDifferences%3FAFC0080256.body
}

Real Cstat::sumDerivs (int parameterIndex, bool isRespar)
{
  //## begin Cstat::sumDerivs%416D5A470197.body preserve=yes

    //dModel = container of array containers of derivatives for each parameter.
    ArrayContainer& dm = dModel()[parameterIndex];
    Real dSdpj(0);

    ArrayContainer::iterator d = dm.begin();
    ArrayContainer::iterator dEnd = dm.end();
    if (!isRespar)
    {
       while(d != dEnd) 
       {
          size_t spectrumIndex = d->first;
          const RealArray& dv = d->second;
          RealArray dSdpA (m_firstDerivCoefficient[spectrumIndex]);
          dSdpA *= dv;
          dSdpj += -2.0*dSdpA.sum();
          if (false)
          {
	      size_t N = m_firstDerivCoefficient[spectrumIndex].size();
              tcout << N << std::endl;
	      std::vector<Real> PS(N);
	      std::partial_sum(&dSdpA[0],&dSdpA[0]+N,PS.begin());
	      tcout << " Spectrum " << d->first << " Parameter# " << parameterIndex  
                              << " D:  " << dSdpj << '\n';
	      for (size_t j = 0; j < N; ++j)
	      {
	          tcout << j << " " << std::setw(12) 
		        << std::setw(12) << m_firstDerivCoefficient[spectrumIndex][j] << " "
		        << std::setw(12) << dv[j]  << " "
		        << std::setw(12) << dSdpA[j] << " "
		        << std::setw(12) << PS[j]  << '\n'; 
	      }
	      tcout << " d " << spectrumIndex << "  " << dSdpj << '\n';  
          }               
          ++d;
       }
    }
    else
    {
       std::map<size_t,ArrayContainer>::const_iterator dFdPContainer = dRM().find(parameterIndex);
       // For response parameters, dFdPContainer should only have
       // 1 entry, since only 1 spectrum is associated with reponse.
       int specNum = dFdPContainer->second.begin()->first;
       const RealArray& dFdP = dFdPContainer->second.begin()->second;
       RealArray dSdpA(m_firstDerivCoefficient[specNum]);
       dSdpA *= dFdP;
       dSdpj += -2.0*dSdpA.sum();
    }
    return dSdpj;

  //## end Cstat::sumDerivs%416D5A470197.body
}

Real Cstat::sumSecondDerivs (int pi, int pj, bool isPiResp, bool isPjResp)
{
  //## begin Cstat::sumSecondDerivs%416D5AAE0267.body preserve=yes
  Real alpha_ij=.0;
  ArrayContainer::const_iterator secondCoeffEnd = m_secondDerivCoefficient.end();
  if (!isPiResp && !isPjResp)
  {
     // Calculate (2/var)*(dF/dpi)(dF/dpj) summed over all fit spectra.
     const ArrayContainer& piBins = dModel().find(pi)->second;
     const ArrayContainer& pjBins = dModel().find(pj)->second;
     ArrayContainer::const_iterator piSpec = piBins.begin();
     ArrayContainer::const_iterator piEnd = piBins.end();
     ArrayContainer::const_iterator pjEnd = pjBins.end();
     while (piSpec != piEnd)
     {
        // ASSUMES piBins and pjBins containers have same number of
        // RealArrays, which are indexed by the same spectra numbers.
        // Does NOT ASSUME that iterating through both in parallel will
        // grab RealArrays corresponding to the same spectrum.
        size_t specNum = piSpec->first;
        ArrayContainer::const_iterator pjSpec = pjBins.find(specNum);
        ArrayContainer::const_iterator coeffSpec = m_secondDerivCoefficient.find(specNum);  
        if (pjSpec == pjEnd || coeffSpec == secondCoeffEnd)
        {
           throw RedAlert("Cstat calc: Second derivatives array container size mismatch.");
        }
        RealArray secondDeriv(coeffSpec->second);
        secondDeriv *= piSpec->second;
        secondDeriv *= pjSpec->second;
        alpha_ij += secondDeriv.sum();
        ++piSpec;
     } 
  }
  else
  {
     // 1 or both pars are response pars.   In all 3 possible
     // cases, only 1 spectrum (at most) applies.
     size_t onlySpec = 0;
     std::map<size_t,ArrayContainer>::const_iterator piContainer = 
                dModel().find(pi);
     std::map<size_t,ArrayContainer>::const_iterator pjContainer = 
                dModel().find(pj);
     if (isPiResp)
     {
        piContainer = dRM().find(pi);
        if (piContainer == dRM().end())
        {
           throw RedAlert("Cstat 2nd deriv: missing response parameter");
        }
        onlySpec = piContainer->second.begin()->first;
     }
     if (isPjResp)
     {
        pjContainer = dRM().find(pj);
        if (pjContainer == dRM().end())
        {
           throw RedAlert("Cstat 2nd deriv: missing response parameter");
        }
        size_t tmp = pjContainer->second.begin()->first;
        if (onlySpec && (tmp != onlySpec))
        {
           // 2 response pars belonging to different spectra.
           // No terms contribute to 2nd derivative.
           return 0.0;
        }
        onlySpec = tmp;
     }
     const RealArray& piSpec = piContainer->second.find(onlySpec)->second;
     const RealArray& pjSpec = pjContainer->second.find(onlySpec)->second;
     ArrayContainer::const_iterator coeffSpec = m_secondDerivCoefficient.find(onlySpec);  
     if (coeffSpec == secondCoeffEnd)
     {
        throw RedAlert("Cstat calc: Second derivatives array container size mismatch.");
     }
     RealArray secondDeriv(coeffSpec->second);
     secondDeriv *= piSpec;
     secondDeriv *= pjSpec;
     alpha_ij = secondDeriv.sum();
  }
  alpha_ij *= 2.0;  
  return alpha_ij;
  //## end Cstat::sumSecondDerivs%416D5AAE0267.body
}

std::pair<Real,Real> Cstat::adjustForFrozen (const SpectralData* spec, const std::vector<Model*>& models, const std::map<Model*,ArrayContainer >& savedValsForFrozen)
{
  //## begin Cstat::adjustForFrozen%448457880227.body preserve=yes
        
    const std::valarray<size_t>& IN = spec->indirectNotice();
    const size_t N = IN.size();
    const size_t specNum = spec->spectrumNumber();

    std::pair<Real,Real> fSums (0.,0.);

    RealArray data (spec->spectrum()[IN]);
    RealArray totModFroz(0., N); 
    RealArray totalModel(0., N);
    
    for (size_t i=0; i<models.size(); ++i)
    {
      Model* mod = models[i];
      std::map<Model*,ArrayContainer >::const_iterator itSaved =
                savedValsForFrozen.find(mod);
      if (itSaved != savedValsForFrozen.end())
      {
         totalModel += itSaved->second.find(specNum)->second[IN];
         totModFroz += mod->foldedModel(specNum)[IN];
      }
      else
      {
         totalModel += mod->foldedModel(specNum)[IN];
      }
    }
    
    fSums.first = (data - totModFroz).sum();
    fSums.second = (totalModel - totModFroz).sum();

   return fSums;
  //## end Cstat::adjustForFrozen%448457880227.body
}

bool Cstat::checkForPoisson ()
{
  //## begin Cstat::checkForPoisson%44982E1202A8.body preserve=yes
   bool allPoisson = true;
   std::map<size_t,SpectralData*>::const_iterator itSpec = 
                fit->spectraToFit().begin();
   std::map<size_t,SpectralData*>::const_iterator itSpecEnd = 
                fit->spectraToFit().end();
   while (itSpec != itSpecEnd)
   {
      const SpectralData* sd = itSpec->second;
      if (!sd->isPoisson())
      {
         allPoisson = false;
         break;
      }
      if (sd->background())
      {
         if (!sd->background()->data()->isPoisson())
         {
            allPoisson = false;
            break;
         }
      }
      ++itSpec;
   }
   return allPoisson;
  //## end Cstat::checkForPoisson%44982E1202A8.body
}

// Additional Declarations
  //## begin Cstat%3B7BFB790023.declarations preserve=yes
  //## end Cstat%3B7BFB790023.declarations

//## begin module%3C1786D801AD.epilog preserve=yes
//## end module%3C1786D801AD.epilog
